<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="项目名称" prop="projectName">
        <el-input
          v-model="queryParams.projectName"
          placeholder="请输入项目名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="参建单位类型" prop="deptType">
        <el-select v-model="queryParams.deptType" placeholder="请选择参建单位类型" clearable>
          <el-option
            v-for="dict in pro_dept_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="参建单位名称" prop="deptName">
        <el-input
          v-model="queryParams.deptName"
          placeholder="请输入参建单位名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['manage:proProjectInfoDepts:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['manage:proProjectInfoDepts:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['manage:proProjectInfoDepts:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['manage:proProjectInfoDepts:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="proProjectInfoDeptsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="项目名称" align="center" prop="projectName" />
      <el-table-column label="参建单位类型" align="center" prop="deptType">
        <template #default="scope">
          <dict-tag :options="pro_dept_type" :value="scope.row.deptType"/>
        </template>
      </el-table-column>
      <el-table-column label="参建单位名称" align="center" prop="deptName" />
      <el-table-column label="参建单位编号" align="center" prop="deptCode" />
      <el-table-column label="数据状态" align="center" prop="isDel">
        <template #default="scope">
          <dict-tag :options="sys_is_del" :value="scope.row.isDel"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['manage:proProjectInfoDepts:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['manage:proProjectInfoDepts:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改参建单位对话框 -->
    <el-dialog :title="title" v-model="open" width="800px" append-to-body>
      <el-form ref="proProjectInfoDeptsRef" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="项目主键" prop="projectName">
          <el-input v-model="form.projectName" :disabled="form.id" placeholder="请输入项目主键" />
        </el-form-item>
        <el-form-item label="参建单位类型" prop="deptType">
          <el-select v-model="form.deptType" placeholder="请选择参建单位类型">
            <el-option
              v-for="dict in pro_dept_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="参建单位名称" prop="deptName">
          <el-input v-model="form.deptName" placeholder="请输入参建单位名称" />
        </el-form-item>
        <el-form-item label="参建单位编号" prop="deptCode">
          <el-input v-model="form.deptCode" placeholder="请输入参建单位编号" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ProProjectInfoDepts">
import { listProProjectInfoDepts, getProProjectInfoDepts, delProProjectInfoDepts, addProProjectInfoDepts, updateProProjectInfoDepts } from "@/api/manage/proProjectInfoDepts";

const { proxy } = getCurrentInstance();
const { pro_dept_type, sys_is_del } = proxy.useDict('pro_dept_type', 'sys_is_del');

const proProjectInfoDeptsList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    projectName: null,
    deptType: null,
    deptName: null,
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询参建单位列表 */
function getList() {
  loading.value = true;
  listProProjectInfoDepts(queryParams.value).then(response => {
    proProjectInfoDeptsList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    projectId: null,
    deptType: null,
    deptName: null,
    deptCode: null,
    isDel: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("proProjectInfoDeptsRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加参建单位";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getProProjectInfoDepts(_id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改参建单位";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["proProjectInfoDeptsRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateProProjectInfoDepts(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addProProjectInfoDepts(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除参建单位编号为"' + _ids + '"的数据项？').then(function() {
    return delProProjectInfoDepts(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('manage/proProjectInfoDepts/export', {
    ...queryParams.value
  }, `proProjectInfoDepts_${new Date().getTime()}.xlsx`)
}

getList();
</script>
